var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp, _class2, _temp3;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { cloneElement } from "react";
import cx from "classnames";
import { CoreComponent, setCorePropTypes, setCorePropDefaults, getValidProps, ROLE } from "../../lib";
import Drawer from "../Drawer/Drawer.js";
import MainContent from "./MainContent.js";
import "./Main.css";

var MainDrawer = (_temp = _class = function (_Drawer) {
  _inherits(MainDrawer, _Drawer);

  function MainDrawer() {
    _classCallCheck(this, MainDrawer);

    return _possibleConstructorReturn(this, _Drawer.apply(this, arguments));
  }

  return MainDrawer;
}(Drawer), _class.defaultProps = {
  renderAs: "div",
  uirole: ROLE.DRAWER,
  attach: "left"
}, _temp);
var Main = (_temp3 = _class2 = function (_CoreComponent) {
  _inherits(Main, _CoreComponent);

  function Main() {
    var _temp2, _this2, _ret;

    _classCallCheck(this, Main);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp2 = (_this2 = _possibleConstructorReturn(this, _CoreComponent.call.apply(_CoreComponent, [this].concat(args))), _this2), _this2.renderChild = function (child, props) {
      var role = child.props.uirole;
      var ref = function ref(c) {
        _this2[role] = c;
      };
      if (typeof child.ref !== "string") {
        ref = _this2.chainFunction(child.ref, ref);
      }
      return cloneElement(child, _extends({}, props, {
        ref: ref,
        uiclass: _this2.childPrefix(role)
      }));
    }, _temp2), _possibleConstructorReturn(_this2, _ret);
  }

  Main.prototype.render = function render() {
    var _this3 = this;

    var _getValidProps = getValidProps(this.props),
        Component = _getValidProps.renderAs,
        className = _getValidProps.className,
        header = _getValidProps.header,
        footer = _getValidProps.footer,
        uiclass = _getValidProps.uiclass,
        children = _getValidProps.children,
        props = _getValidProps.props;

    var classes = {
      "with-header": header && !footer,
      "with-footer": !header && footer,
      "with-header-and-footer": header && footer
    };

    var uiClassCore = cx(className, classes);
    delete props.className;

    return React.createElement(
      Component,
      _extends({ className: uiClassCore }, props),
      React.Children.map(children, function (child) {
        if (typeof child.props !== "undefined" && typeof child.props.uirole !== "undefined") {
          switch (child.props.uirole) {
            case ROLE.CONTENT:
              return _this3.renderChild(child, { uiclass: uiclass });
            default:
              return child;
          }
        }
        return child;
      })
    );
  };

  return Main;
}(CoreComponent), _class2.propTypes = setCorePropTypes({
  header: "bool",
  footer: "bool"
}), _class2.defaultProps = setCorePropDefaults({
  renderAs: "main",
  uirole: ROLE.MAIN,
  fixed: false,
  header: false,
  footer: false
}), _class2.Drawer = MainDrawer, _class2.Content = MainContent, _temp3);


export default Main;