function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import _ from "lodash";

var defaultRect = {
  x: 0,
  y: 0,
  top: 0,
  bottom: 0,
  left: 0,
  right: 0,
  width: 0,
  height: 0
};

var UIGlobals = function UIGlobals() {
  _classCallCheck(this, UIGlobals);

  this.getScreenDimensions = function () {
    if (document && document.body) {
      return document.body.getBoundingClientRect();
    }
    return defaultRect;
  };

  this.applySetting = function (param, value) {
    localStorage.setItem(param, value);
  };

  this.readSetting = function (param) {
    return localStorage.getItem(param);
  };
};

export default new UIGlobals();