"use strict";

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _classnames = require("classnames");

var _classnames2 = _interopRequireDefault(_classnames);

var _lib = require("../../lib");

var _CardHeader = require("./CardHeader");

var _CardHeader2 = _interopRequireDefault(_CardHeader);

var _CardContent = require("./CardContent");

var _CardContent2 = _interopRequireDefault(_CardContent);

var _CardFooter = require("./CardFooter");

var _CardFooter2 = _interopRequireDefault(_CardFooter);

require("./Card.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Card = (_temp = _class = function (_CoreComponent) {
  _inherits(Card, _CoreComponent);

  function Card() {
    _classCallCheck(this, Card);

    return _possibleConstructorReturn(this, _CoreComponent.apply(this, arguments));
  }

  Card.prototype.render = function render() {
    var _this2 = this;

    var _getValidProps = (0, _lib.getValidProps)(this.props),
        Component = _getValidProps.renderAs,
        className = _getValidProps.className,
        striped = _getValidProps.striped,
        children = _getValidProps.children,
        props = _getValidProps.props,
        inherited = _getValidProps.inherited;

    var classes = {
      "ui-card-striped": striped
    };

    var uiClassCore = (0, _classnames2.default)(className, classes);
    delete props.className;
    return _react2.default.createElement(
      Component,
      _extends({}, props, { className: uiClassCore }),
      _react2.default.Children.map(children, function (child) {
        if (typeof child.props !== "undefined" && typeof child.props.uirole !== "undefined") {
          return _this2.renderChild(child, inherited);
        }
        return child;
      })
    );
  };

  return Card;
}(_lib.CoreComponent), _class.propTypes = (0, _lib.setCorePropTypes)({
  striped: "bool"
}), _class.defaultProps = (0, _lib.setCorePropDefaults)({
  renderAs: "div",
  uirole: _lib.ROLE.CARD,
  striped: false
}), _class.Header = _CardHeader2.default, _class.Content = _CardContent2.default, _class.Footer = _CardFooter2.default, _temp);
exports.default = Card;
module.exports = exports["default"];